
var TxtMarkDown = function ( dom_id ) {
    var _this = this;
    this.textDom = document.getElementById( dom_id );

    var insertText = function (txt, start, end) {
        start = start || 0;
        end = end || start;
        var tmp = _this.textDom.value.substr(end);
        _this.textDom.value = _this.textDom.value.substr(0,start) + txt + tmp;
    }
    var removeText = function ( start, end ) {
        _this.textDom.value = _this.textDom.value.substr(0,start) + _this.textDom.value.substr(end);
    }
    var copyStr = function ( str, len ) {
        return (new Array(len+1)).join( str );
    }

    var getLinesText = function ( start, end ) {
        start = start || _this.textDom.selectionStart;
        end = end || _this.textDom.selectionEnd;
        var lines = _this.textDom.value.split('\n')
            , len = 0
            , result = [];
        var line_start = 0, line_end = 0;
        for ( var i in lines ) {

            line_end = line_start + lines[i].length;

            if ( start <= line_end ) {
                result.push( { value: lines[i], start: line_start} );
            }

            if ( end <= line_end ) {
                break;
            }

            line_start = line_end + 1;	// 換行
        }
        return result;

    }

    var eventKeyDown = function ( e ) {
        switch ( e.keyCode ) {
            case 9: // tab
                var lines = getLinesText()
                    , line_start = this.selectionStart
                    , line_end = this.selectionEnd;
                if( this.selectionStart == this.selectionEnd && e.shiftKey )
                {
                        var sub = 4 - ( lines[0].value.length % 4 );
                        line_start += sub;
                        line_end += sub;
                        insertText( copyStr(' ', sub), this.selectionStart);

                } else {
                    if ( e.shiftKey ) {

                    } else {

                    }
                    for( var i = lines.length - 1; i >= 0; i-- ) {
                        console.log( lines[i] );
                        insertText('    ', lines[i].start);
                    }
                }
                this.setSelectionRange( line_start, line_end);
                return false;
            case 36:    // Home
                var lines = getLinesText();
                var idx = lines[0].value.match(/^[ ]*/).toString().length + lines[0].start;
                idx = idx == this.selectionStart ? lines[0].start: idx;
                this.setSelectionRange( idx, idx);
                return false;
            default:
                console.log( e.keyCode );
        }
    }


    if ( this.textDom ) {

        // this.textDom.addEventListener('keydown', function(e) {
        // 	return false;
        // 	return eventKeyDown.apply( this, [e] );
        // });
        this.textDom.onkeydown = eventKeyDown;
        // this.textDom.addEventListener('keypress', function(e) {
        // 	eventKeyPress.apply( this, [e] );
        // });
        
    }

    return this;
};